var idEstudio;

$(document).ready(
	function() {
		inicial();
	}
);

function inicial(){
	limpiarTabla();
	realizaConsulta();
	inicializarBotones();
	$("table thead tr").addClass("encabezado");
}

function limpiarTabla(){	
	$('#divTablaIn').remove();
	var div = '<div id="divTablaIn"></div>';
	$('#divTablaExt').append(div);
	var tabla = $("<table class='table table-striped'/>").attr('id',"cataEstudio");       
	$("#divTablaIn").append(tabla);	
}

function realizaConsulta(){				
	// Obtener numero de menu
	var menu        = $("#pmn").val();
	var menuRegreso = $("#pmnReturn").val();
	var namespace = "/catalogos/estudiosTrans/";
    var rowId=null;
    var oTable=null;
     oTable=$('#cataEstudio').dataTable({		    
	   "bAutoWidth": false,
		"oLanguage":{	"sProcessing":     "Procesando...",
						"sLengthMenu":     "Mostrar _MENU_ registros",
						"sZeroRecords":    "Sin eventos encontrados",
						"sEmptyTable":     "Sin eventos encontrados",
						"sInfo":           "Mostrando  _START_ al _END_ de  _TOTAL_ ",
						"sInfoEmpty":      "0 registros",
						"sInfoFiltered":   "(filtrado de un total de _MAX_ registros)",
						"sSearch":         "Buscar:",
						"sInfoThousands":  ",",
						"sLoadingRecords": "Cargando...",
						"oPaginate": {
							"sFirst":    "Primero",
				        	"sLast":     "&Uacute;ltimo",
				        	"sNext":     "Siguiente",
				        	"sPrevious": "Anterior"
				    	}
				},
		"iDisplayLength": 10,
		"bInfo"     : false,
		"bFilter"   : true,
		"bSort"     : false,
		"bPaginate" :true,
		"sPaginationType" : "full_numbers",
		"aaSorting": [],
		"sAjaxSource": "listadoEstudiosTrans",
		"sAjaxDataProp":"", 
	    "aoColumns": [
						{"sTitle":"Nombre", 					"mDataProp":"nombre",		"bSearchable": true, sWidth : "100px"},
						{"sTitle":"Revenue Share", 				"mDataProp":"revenueShare","bSearchable": true, sWidth : "50px"},
						{"sTitle":"Accion"					,"mDataProp":"nombre"			,"bSearchable":true,	sWidth:"30px"}
	          			],
	    		        'fnRowCallback': function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
	    		        
	    		        	var link = '<a onClick="actualizaEstudio('+aData["idEstudio"]+')" data-toggle="modal" data-target="#modalAgregaActualiza"> ' + aData["nombre"] +'</a>';
	    		        	var button = '<button class="btn btn-danger" type="button" onclick="eliminar(' + aData["idEstudio"] + ')">Eliminar</button> ';
	    		        	$(nRow).attr("id",aData["idEstudio"]);
	    		        	$('td:eq(0)', nRow).html(link);
		          			$('td:eq(1)', nRow).html(aData["revenueShare"]);
		          			$('td:eq(2)', nRow).html(button);
	   		       		}
		});
     
}

function validarAgregar(){
	
	$("#forma").validate(
		      {
		        rules: 
		        {
		        	nombreEstudio: 
		          {
		            required: true,
		            maxlength: 50,
		            regex:"^[a-zA-Z0-9 ]+$"
		          }
		        },
		        messages: 
		        {
		        	nombreEstudio: 
		          {
		            required: "Nombre del Estudio es obligatorio.",
		            maxlength: "Nombre no debe exceder 50 caracteres",
		            regex: "Nombre debe ser con caracteres alfanum\u00E9ricos"
		          }
		        }
	});
	
	$.validator.addMethod("regex",function(value,element,regexp){
	      var re= new RegExp(regexp);
	      return this.optional(element) || re.test(value);
	},"Only Characters from A-z");
}

function eliminar(id){
	if(confirm('¿Esta seguro de borrar este registro?')){
		var jsonString = '{"idEstudio" : "' + id + '"}';
		var stringJson = JSON.parse(jsonString);
		callActionAjax("/catalogos/estudiosTrans/eliminaEstudioTrans", stringJson, procesaRespuestaActualiza);
	}
}

function inicializarBotones(){
	$("#nuevo").click(function()  
	{		
		window.location.href = contextPath + "/catalogos/estudiosTrans/dirigirAgregarEstudioTrans.action?pmn=211&pmnReturn=211";				
	});
}

function regreso(){	
	var menu = $("#pmn").val();
	if(menu == '' || menu == null || menu == undefined)
		menu = 211;
	window.location.href = contextPath + "/catalogos/estudiosTrans/index.action?pmn=" + menu;
}

function actualizaEstudio(idEstud) {	
	idEstudio = idEstud;
	llamaObtenEstudio(idEstudio);
}

function llamaObtenEstudio(idEstudio) {
	var jsonString = '{"idEstudio" : "'+ idEstudio +'"}';
	var stringJson = JSON.parse(jsonString);
	callActionAjax( "/catalogos/estudiosTrans/llamaObtenEstudio", stringJson, procesaRespuestaObtenEstudio);
}

function procesaRespuestaObtenEstudio(jsonData) {
	var est = jsonData.estudio;
	var reps = jsonData.reportes;
	var rep;
	//debugger
	$('#inpNombreEstudio').val(est.nombre);
	$('#inpRevenueShare').val(est.revenueShare);
}

function llamaActualizaEstudio() {
	var nombre = $('#inpNombreEstudio').val();
	var revenue = $('#inpRevenueShare').val();
	var jsonString = '{"idEstudio" : "'+ idEstudio + '", "nombreEstudio" : "' + nombre + '", "revenueShare" : "' + revenue + '"}';
	var stringJson = JSON.parse(jsonString);
	callActionAjax( "/catalogos/estudiosTrans/llamaActualizaEstudio", stringJson, procesaRespuestaActualiza);

}

function procesaRespuestaActualiza(jsonData) {
	
	var seRepite = jsonData.seRepiteSigla;
	
	$('#modalAgregaActualiza').modal('hide');
	
	if(!seRepite) {
		showMessage("Actualizado con exito");
	}else {
		showError("La sigla se repite en otro Estudio.");
	}
	
	inicial();	
}

function callActionAjax(actionRoute, jsonActionParameter, functionProcessor){
	 $.ajax({
	     url: contextPath + actionRoute,
	     type: 'POST',
	     data:  jsonActionParameter, 
		 dataType: "json",
	     success:function(response){ 
	    	 functionProcessor(response);    
	     },
	     error:function(jqXhr, textStatus, errorThrown){
	         showError("Problemas al enviar los datos.");
	     }
	 });	
}